<?php
/**
 * @package Extension WebEngage for Joomla
 * @copyright (C) 2010 - 2013, Webklipper Technologies Pvt Ltd
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.application.component.view');

class WebengageViewWebengage extends JViewLegacy
{
	function __construct($config = array()) 
        {
		$doc = & JFactory::getDocument();
		$doc->addStyleSheet("../media/com_webengage/css/main.css");
		  
                parent::__construct($config = array());
        }
        
        function display($tpl = null) 
        {
                $this->licenseCode = $this->get('LicenseCode');
                $this->widgetStatus = $this->get('WidgetStatus');

		if(strlen($this->licenseCode) > 0){
	 		if($this->isWebengagePluginEnabled() == false){
	 			JFactory::getApplication()->enqueueMessage(JText::_('Your "WebEngage Frontend" Plugin is NOT enabled. Please enable it through "Plug-in Manager"'), 'warning');
	 		}
	 	}
 
                if (count($errors = $this->get('Errors'))) 
                {
                        JError::raiseError(500, implode('<br />', $errors));
                        return false;
                }
                
                $mWeAction = JRequest::getVar('weAction');
		if($mWeAction !== NULL && strlen($mWeAction) > 0){
		  $this->handleRequest($mWeAction);
		}
                
                // Display the template
                parent::display($tpl);
        }
        
        /*******************************************/
	public function isWebengagePluginEnabled()
        {
        	$user = JFactory::getUser();
		$db = JFactory::getDBO();

		$levels = implode(',', $user->getAuthorisedViewLevels());
		
		$query = "select * from #__extensions where `name` like '%Webengage%' and `type` = 'plugin' and `state` >= 0 and `access` in (" . $levels . ") limit 1";
		$db->setQuery($query);
		$resultSet = $db->loadAssocList();
		
		if($resultSet[0]['enabled'] > 0){
			return true;
		} else{
			return false;
		}
        }

        public function redirectToUrl($mRedirectUrl)
	{
	    $app = JFactory::getApplication();
	    $app->redirect($mRedirectUrl);
        }
        
        public function handleRequest($mWeAction) 
	{
	      echo "<hr />Action  = ".$mWeAction;
	      if(isset($mWeAction))
	      {
		  if ($mWeAction === 'wp-save') {
		      $message = $this->update_webengage_options();
		      $this->redirectToUrl(JRoute::_(JURI::current() . '?option='.JRequest::getVar('option')."&".$message[0]."=".urlencode($message[1]), false));
	
		  } else if ($mWeAction === 'reset') {
		      $message = $this->reset_webengage_options($mReq);
		      $this->redirectToUrl(JRoute::_(JURI::current() . '?option='.JRequest::getVar('option')."&".$message[0]."=".urlencode($message[1]), false));

		  } else if ($mWeAction === 'activate') {
		      $message = $this->activate_we_widget($mReq);
		      $this->redirectToUrl(JRoute::_(JURI::current() . '?option='.JRequest::getVar('option')."&".$message[0]."=".urlencode($message[1]), false));

		  } else if ($mWeAction === 'discardMessage') {
		      $this->discard_status_message($mReq);
		      $this->redirectToUrl(JRoute::_(JURI::current() . '?option='.JRequest::getVar('option'), false));
		  }
	      }
	}    
  
	// discarding the widget status message, in case user activated account on WebEngage Dashboard
	function discard_status_message () {
	      $this->getModel()->setWidgetStatus('ACTIVE');
	}
  
	// resetting webengage option
	function reset_webengage_options() {
	      $this->getModel()->setLicenseCode('');
	      $this->getModel()->setWidgetStatus('');
	      
	      return array("message", "Your WebEngage options are deleted. You can signup for a new account.");
	}

	// updating webengage option
	function update_webengage_options() {
	      $wlc = JRequest::getVar('webengage_license_code');
	      $vm = urldecode(JRequest::getVar('verification_message'));
	      $wws = JRequest::getVar('webengage_widget_status');
	      
	      $wlc = (isset($wlc) && strlen($wlc) > 0 ) ? $wlc : "";
	      $vm = (isset($vm) && strlen($vm) > 0 ) ? $vm : "";
	      $wws = (isset($wws) && strlen($wws) > 0 ) ? $wws : "ACTIVE";
		
	      if(!empty($wlc)) {
		      $this->getModel()->setLicenseCode(trim($wlc));
		      $this->getModel()->setWidgetStatus($wws);
		      $msg = !empty($vm) ? $vm : "Your WebEngage widget license code has been updated.";
		      return array("message", $msg);
	      } else {
		      return array("error-message", "Please add a license code.");
	      }
	}

	// activating webengage widget
	function activate_we_widget(){
	      $mLicenseCodeOld = $this->get('LicenseCode');
	      
	      $mLicenseCodeNew = JRequest::getVar('webengage_license_code');
	      $wws = JRequest::getVar('webengage_widget_status');
	      
	      $mLicenseCodeNew = (isset($mLicenseCodeNew) && strlen($mLicenseCodeNew) > 0 ) ? $mLicenseCodeNew : "";
	      $wws = (isset($wws) && strlen($wws) > 0 ) ? $wws : "ACTIVE";
		
	      if ($mLicenseCodeNew === $mLicenseCodeOld) {
		      $this->getModel()->setWidgetStatus($wws);
		      $msg = "Your weplugin installation is complete. You can do further customizations from your WebEngage dashboard.";
		      return array("message", $msg);
	      } else {
		      $msg = "Unauthorized weplugin activation request";
		      return array("error-message", $msg);
	      }
	}
}

